# 一、棱镜是什么
小桔棱镜是一款专注于移动端用户行为分析的工具，从最初的埋点数据可视化，到用户行为回放、行为检测，再到用户行为分析平台，始终致力于**最大限度的发挥用户行为数据的价值**。本篇我们会从产品设计理念和技术实现思路上对棱镜进行整体介绍。

### 功能结构图
![](https://view.didistatic.com/static/dcms/1jt5q5bqvkesdosxf_1114x435.png)

- - - -

# 二、为什么要做棱镜
刷过《神探夏洛克》的同学都会惊叹于Sherlock从对方的一举一动中提取关键信息的画面：

<img src="https://view.didistatic.com/static/dcms/1jt5qoatskemik6cu_558x312.jpeg" width="372" hegiht="208" align=center />

而移动端作为我们与用户交流的几乎唯一载体，其上也承载着很多我们未发觉但很有价值的信息，小到用户一次细微操作暴露出的体验问题，大到对用户的产品偏好、使用习惯、消费意愿的感知，都是值得我们去深度挖掘的，那我们如何才能拥有这样的能力呢？仿佛是有千万个Sherlock在时刻帮我们贴身观察千万个用户一样，**小桔棱镜就为此而生**。

- - - -

# 三、棱镜都有哪些能力
小桔棱镜从最初诞生想法至今已有近两年时间，经过我们不断的贴近业务思考实践，目前整体演变为四部分：

**第一部分**是覆盖埋点全流程的移动端解决方案，包括埋点数据可视化范畴的`多维度PV/UV`、`热力图`、`转化率漏斗`、`页面停留时长`等功能，以及埋点辅助范畴的`快速注册`、`测试`工具。这部分的意义在于：它改变了大家日常看数据的方式，**让原本就擅长使用数据的同学可以更便捷的用数据，让原本不擅长使用数据的同学开始喜欢用数据**。

**第二部分**是棱镜更具创新性的部分，也是后续能力的基础，我们基于自研的用户操作行为标识指令，实现了`APP端用户行为回放`（视频回放 / 文字回放），并配有灵活的检索支持，来助力业务同学的日常分析工作。这部分的意义在于：相比于传统的静态埋点数据，它**提供了用户的动态行为并赋予大家用上帝视角观察这些行为的能力**，给业务同学的日常分析带来新的可能性。

**第三部分**是`APP端用户行为检测`，基于自研的用户操作行为标识指令以及语义化行为描述方案，动态下发策略并实时检测用户行为，来实现场景化营销/留咨等能力。这部分的意义与第二部分相近，在赋予大家观察用户的动态行为之上，提供了实时运用用户行为的能力，同样给业务带来新的可能性。

**第四部分**同样是在第二部分之上演化出的用户行为分析平台，基于用户行为数据构建出了`用户行为标签系统`、`用户分群`、`高价值行为分析`以及`行为路径`等功能。这部分的意义在于能够汇总并计算我们采集到的行为数据，**最大限度的去挖掘用户行为数据的价值**。

接下来我们详细介绍各部分功能：

- - - -

# Part.1 埋点全流程解决方案
如上文介绍，这部分的重点在于移动端埋点数据可视化，单纯从技术角度看并非稀奇之事，业内应该有很多类似实践，因此我们更多去讨论它的应用价值：

## 1.1 对现有模式的思考
就拿我们集团来举例，大家日常要看一些页面埋点数据时大概有这两种途径：

**途径一**  依赖各自BU的数仓计算整理
1. 向数仓同学表明自己的数据查看诉求后，数仓同学消化需求并排期开发。
2. 数仓同学依据业务埋点说明文档，去Omega底表检索目标数据并计算产出到Excel。
3. 需求方拿到Excel，基于埋点ID来查看对应数据。

**途径二**  直接去Omega平台查询
1. 依据业务埋点说明文档寻找目标页面内的埋点ID。
2. 在Omega埋点管理页面检索到目标埋点并查看数据。
3. 如果对数据维度有更多要求，则需要前往提取工具自己写SQL计算。

## 1.2 棱镜带来的改变
在有了小桔棱镜后，流程会简化到你只需：
1. 打开棱镜版APP查看数据即可。

<img src="https://view.didistatic.com/static/dcms/olv821jdm5keph38zf_1242x2208_compress.jpeg" width="272" hegiht="480" align=center />

注：展示数据已作处理，仅供介绍。

相信这样的改变还是令人兴奋的，那么除去基本的把埋点数据“镶”在页面元素上以外，我们还做了哪些工作来优化这个流程呢？ 或者说数据可视化的最佳姿势应该是什么？

### 1.2.1 统一的埋点规范与数据计算方案
数据需求方几乎从来不会满足于只看笼统的PV/UV数据，在我们交流的过程中大家最基本的诉求有：`分城市查看`、`分用户类型查看`、`被复用埋点分位置和分ID查看`等，对数据源的多维度提出了很多要求。

因此我们联合**车服数仓同学**制定了一套统一的埋点规范和数据计算方案，把控从埋点上报、计算、存储到请求查看的全流程，保证用户在APP端简单操作就可以轻松切换数据维度。


### 1.2.2 自然的交互设计
一方面通常一个页面中的埋点众多，另一方面数据可视化也涵盖好几块功能，如多维度PV/UV、热力图、转化率漏斗、页面停留时长等，这种情况下良好的交互体验和UI设计才能保证用户在复杂的页面和数据中可以游刃有余。这对棱镜也提出了很高的要求。

在整个迭代过程中我们与设计师不断碰撞，我自己身为一名开发也时常思考如何给用户更好的体验，经过了很多个版本的迭代，最近这一版虽已“面目全非”，但确是我们最满意的一版，我甚至能感受到用户在使用过程中的那种愉悦之情。

- - - -

# Part.2 行为回放
## 2.1 为什么要做回放？
最初是在共享汽车业务中碰到了一些用户问题，经调研归纳后突然意识到一个问题：虽然我们每天都在耕耘移动端产品，可是**我们根本不知道我们的用户到底在如何使用我们精心设计的产品**，可能用户对一个页面或一个按钮的认知与我们设计时的初衷有所偏差甚至根本不同，可能我们觉得一个很合理的按钮位置对于用户来说并不容易找到，类似的问题应该会有很多，这就造成了我们与用户之间的认知偏差。

因此当时有一股冲动就是要让大家也能容易的看到这些问题，给大家一个拥有上帝视角理解用户的能力，再结合灵活的筛选方式，帮助大家去**发现那些隐蔽而又迫切的用户问题**。

<img src="https://view.didistatic.com/static/dcms/3pwfx1lms3kepi2viv_1242x2208_compress.jpeg" width="272" hegiht="480" align=center />

## 2.2 回放如何做？
有了冲动，可实际情况是在我的脑海里从来没有过类似的实践经验，所以就全靠想象起步了。

最初浮现在我脑海里的是”拼图思路“：如果能唯一标记出用户的每一步操作，并且能维护一个字典来存储用户操作标识和页面截图的对应关系，那么用户的一组操作就可以被转换成一组截图，再把这组截图连续播放就拼成了一个回放视频。这个思路我深入尝试过，遇到了诸如用户操作标识不唯一、字典难采集和维护（鉴于用户隐私问题，只能在内部测试阶段采集字典）、拼装视频效果差等问题，不符合期望，因此进展一度停滞。

> 并不理想的“拼图思路”  

![](https://view.didistatic.com/static/dcms/olv82i927kesf487y_2052x474_compress.png)

也是得益于持续耕耘小桔棱镜，同时期的我还在思考埋点全流程解决方案下的自动埋点如何实现的问题，正好当时对移动端页面元素的唯一标识有了新思路，猛然发现这个新思路或许可以驱动回放的实现，因此就有了酷炫的**通过指令驱动回放的思路，功能形态就是可以做到在APP上真实的模拟用户操作**。

> 成功落地的指令驱动思路  

![](https://view.didistatic.com/static/dcms/1jt5q5bqvkesfm9he_2063x590_compress.png)

## 2.3 方案详细阐述
回放部分的整体方案可以详细讨论的内容有很多，包括但不限于：
1. 理论基础：移动端元素唯一标识的生成策略
2. 指令生成模块的实现思路
3. 指令解析/翻译模块的实现思路
4. 指令调度模块的实现思路
5. 真实数据还原能力的实现思路

限于篇幅问题，本篇就不展开讨论了，后续我们会有**系列文章详细解读，以及开源计划**，欢迎持续关注我们。

- - - -

# Part.3 行为检测

## 3.1 为什么要做行为检测
我认为这个问题甚至都不用刻意回答，因为读这篇文章的每一位同学几乎都能例举出利用行为检测可以做到的事情。我最初想做这部分是源于共享汽车的**降CPO**专项行动，期望基于用户的实时行为来感知用户可能遇到的问题，在界面上做一些专属引导来实时帮助用户解决问题，从而达到降CPO并提升用户体验的目的。后来就是小桔有车的**场景化营销**需求，依然需要行为检测的能力。

## 3.2 行为检测如何做
一些简单策略的行为检测很容易实现，比如支持像“当用户点击过三次某商品时就给用户弹个券”这样的语义时大家都可以很快码出来，但如果要增加一些要求：
1. 支持实时适配新策略，支持动态下发策略。
2. APP全点位支持（跨业务线、跨页面）

此时的实现复杂度就会指数级上升，尝试分解问题后我们梳理出建设这样一套机制必需的基础能力：
1. 通用的行为标识能力，即棱镜自研的用户操作行为标识指令。
2. 通用的策略描述能力，即棱镜已有的语义化行为描述方案。
3. 通用的端侧行为检测引擎。

好在我们持续深耕端侧用户行为，已有的一些实践使得我们已经具备了部分基础，随着基础能力的不断完善，我们最终完美落地了灵活可配的行为检测能力。接下来我们会把行为检测模块**跟高价值行为分析模块完全打通，共用一套行为语义描述方案**，那么未来的场景就是用户可以在高价值行为分析模块直接下发端侧的行为检测策略，做到更智能的触达，想一想都让人兴奋。

- - - -

# Part.4 行为分析平台

## 4.1 为什么要做分析平台

随着对用户行为的不断思考实践，与业务方的持续深入交流，我们发现棱镜仅有的埋点数据可视化和行为回放并不能很好的满足大家对于用户行为分析的所有诉求，比如偏向于个例分析的回放功能不能满足运营同学对于群体的分析诉求，比如大量浏览单个回放后我们发现其实可以总结出用户的一些行为标签，再比如产品运营想知道到底哪些用户行为是高价值行为等等，说明用户行为数据的价值还有很多值得挖掘，这些我们认为是**小桔棱镜的使命**。

在使命之外，给我们信心的是棱镜**拥有一套基于自研指令的用户行为数据**，数据的采集机制和格式本身也很适合去做接下来的事情，这就促成了行为分析平台的诞生。

## 4.2 平台目前都有哪些核心功能

### 4.2.1 用户行为标签系统

* 如上文提及，我们可以基于用户行为数据计算出如产品偏好、消费意愿等的用户行为标签，更具体的例子比如在小桔有车业务中对用户的品牌偏好、车型偏好、租期偏好、服务亮点偏好等的描述。这些最后也会成为我们`人群`划分的基石，用于更多场景中。

* 在技术上，初版的标签系统核心参考用户操作行为的`点击次数`和`停留时长`两个基础维度，并且会考虑多个行为之间的关联关系以及行为发生时间距离当前时间的远近，最后进行排序后得到标签。过程中我们也沉淀了多层Hive表来存放各个阶段产出的数据，每层Hive表都可以被应用到其他的一些分析场景中去。

### 4.2.2 用户分群&&高价值行为分析
* 分析的起点和终点往往是分群。围绕用户行为，分析平台可以支持基于灵活的与或条件来圈定人群，并给出圈定人群的一些核心业务指标作为判断依据来反向衡量操作行为的价值。同时配套的还有人群的导出与导入，便于与其他平台打通。

* 这部分我们期望的工作方式是：结合用户行为筛选条件和业务方关心的业务维度等，反复进行n组人群圈选对比实验后，最终可以得出与业务指标强相关的`高价值行为`和对应的 `人群`。这些 `高价值行为`和`人群` 可以反过来赋能产品设计和营销等工作。

* 有趣的是，**我们还把此模块与端侧行为检测模块打通**，意味着经过反复实验得到的理想行为组合可以下发到移动端进行端侧实时检测，来实现一些场景化触达需求。

<img src="https://view.didistatic.com/static/dcms/1jt5qpip0khzoikct_3095x1812_compress.png" width="773" align=center />

### 4.2.3 行为路径
* 经过我们与业务方的不断深入交流及内部的多次讨论后，明确了`行为路径`需要回答的两个根本问题：`去哪儿`和`去那儿`。`去哪儿`指到访用户在业务线内的整体流向情况，即知道用户都去哪儿了。`去那儿`指到访用户为什么没有按照期望路径访问并形成转化，即知道用户为什么没去那儿。

* 因此有别于常规的漏斗图，该模块的形态是类`桑基图`的形式，从数据流的维度，展示几个`关键节点`，来看目标`人群`在端侧的事件流是怎样的。如此一来大家就可以清晰的明白比如：杭州的用户在进入租车详情页后的点击的事件流分布如何，以及未留资但又流失的`人群`在离开之前做的最多的几件事情是什么。从而帮助我们解答用户为什么有意向却未留资的疑问。

### 4.2.4 用户细查
用户细查算是棱镜APP的PC端承接模块，汇集了上文中的文字回放和用户行为标签，方便大家在日常工作场景下低成本的观察单个用户。

<img src="https://view.didistatic.com/static/dcms/olv821atlhkhzoic7e_3091x1329_compress.png" width="773" align=center />

- - - -

# 四、支持平台与接入
小桔棱镜目前支持移动端的iOS、Android、H5平台，已经集成到滴滴乘客端、车主端、小桔有车端、小桔养车门店端等APP中，助力车服各业务发展。

同时兄弟团队普惠出行的货运、代驾业务及橙心优选业务也在陆续接入中，随着棱镜能力的不断完善，我们也期待可以助力更多的业务，去探索更大的可能性。

- - - -

# 五、系列文章及开源计划
本篇作为棱镜的开篇介绍，目的是希望从整体上给大家一个直观的印象，如上文所说，具体到细节思考就需要大量的篇幅来讨论了，因此在这里也给大家卖个关子，后续我们会持续发布关于棱镜各个方面的思考总结，带大家了解丰富又有趣的棱镜世界，欢迎大家持续关注我们~

- - - -

# 六、写在最后
深耕棱镜这么久，从感性的角度来讲，小桔棱镜仅发挥了移动端用户行为数据价值的30%，我们已有的每项能力都还不足够完善，更不用提那些未知领域了。所以以一句自己喜欢的话作为结尾吧：全情投入，静等花开，道阻且长，行则将至。各位共勉。
